<?xml version="1.0" encoding="UTF-8"?>
<!--

        This file is part of the Squashtest platform.
        Copyright (C) Henix, henix.fr

        See the NOTICE file distributed with this work for additional
        information regarding copyright ownership.

        This is free software: you can redistribute it and/or modify
        it under the terms of the GNU Lesser General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version.

        this software is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public License
        along with this software.  If not, see <http://www.gnu.org/licenses/>.

-->
<databaseChangeLog xmlns="http://www.liquibase.org/xml/ns/dbchangelog"
                   xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
                   xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-2.0.xsd">

  <changeSet id="tm-2.1.0-SQUASH-5232-add-databasechangelog-new-columns" author="jprioux">
    <validCheckSum>8:aeea36396a9ec2a5a73082a8a593b123</validCheckSum>
    <comment>Add Contexts, labels and deployment_id columns to DATABASECHANGELOG Table</comment>
    <sql>
      ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS CONTEXTS VARCHAR(255) DEFAULT NULL;
      ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS LABELS VARCHAR(255) DEFAULT NULL;
      ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS DEPLOYMENT_ID VARCHAR(10) DEFAULT NULL;
    </sql>
  </changeSet>

  <changeSet id="tm-2.1.0" author="dclaerhout">
    <comment>Update TM database version number</comment>
    <update tableName="CORE_CONFIG">
      <column name="VALUE" value="2.1.0"/>
      <where>STR_KEY = 'squashtest.tm.database.version'</where>
    </update>
  </changeSet>

  <changeSet id="tm-2.1.0-add-remote-req-perimeter-status" author="dclaerhout">
    <addColumn tableName="REQUIREMENT_SYNC_EXTENDER">
      <column name="REMOTE_REQ_PERIMETER_STATUS" type="VARCHAR(30)" defaultValue="UNKNOWN">
        <constraints nullable="false"/>
      </column>
    </addColumn>
  </changeSet>

  <changeSet id="tm-2.1.0-SQUASH-4052-delete-owner-in-report-and-chart" author="jprioux">
    <comment>Remove the USER_ID columns and associated foreign keys</comment>
    <dropForeignKeyConstraint baseTableName="CHART_DEFINITION" constraintName="fk_chart_owner"/>
    <dropColumn tableName="CHART_DEFINITION" columnName="USER_ID" />
    <dropForeignKeyConstraint baseTableName="REPORT_DEFINITION" constraintName="fk_report_owner"/>
    <dropColumn tableName="REPORT_DEFINITION" columnName="USER_ID" />
  </changeSet>

  <changeSet id="tm-2.1.0-add-template-configurable-plugin-binding" author="pckerneis">
    <comment>Add the template_configurable_plugin_binding table.</comment>
    <createTable tableName="TEMPLATE_CONFIGURABLE_PLUGIN_BINDING">

      <column name="BINDING_ID" type="BIGINT"
              autoIncrement="true">
        <constraints primaryKey="true" nullable="false"/>
      </column>

      <column name="PROJECT_TEMPLATE_ID" type="BIGINT">
        <constraints nullable="false"
                     foreignKeyName="fk_template_configurable_plugin_binding__template__project_id"
                     references="PROJECT(PROJECT_ID)" />
      </column>

      <column name="PROJECT_ID" type="BIGINT">
        <constraints nullable="false"
                     foreignKeyName="fk_template_configurable_plugin_binding__project__project_id"
                     references="PROJECT(PROJECT_ID)" />
      </column>

      <column name="PLUGIN_ID" type="VARCHAR(50)">
        <constraints nullable="false"/>
      </column>

    </createTable>
  </changeSet>
</databaseChangeLog>
